<template>
  <div class="compatible-stations">
    <BasePriceLoader v-if="showLoader" />
    <div class="row">
      <div class="col-md-6">
        <div class="compatible-stations__title">{{ dataSource.titleFrom }}</div>
        <ObSelect
            v-model="locationsFrom"
            label="Локации, входящие в кластер"
            :isTagbox="true"
            :isDropdown="true"
            :disabled="true"
            :items="locationsListFrom"
            class="compatible-stations__select"
        />
      </div>
      <div class="col-md-6">
        <div class="compatible-stations__title">{{ dataSource.titleTo }}</div>
        <ObSelect
            v-model="locationsTo"
            label="Локации, входящие в кластер"
            :isTagbox="true"
            :isDropdown="true"
            :disabled="true"
            :items="locationsListTo"
            class="compatible-stations__select"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-md-6">
        <div class="compatible-stations__title min">Совместимые станции</div>
        <DataList v-if="ralwayStations && ralwayStations.locationsFrom" :list="ralwayStations.locationsFrom" />
      </div>
      <div class="col-md-6">
        <div class="compatible-stations__title min">Совместимые станции</div>
        <DataList v-if="ralwayStations && ralwayStations.locationsTo" :list="ralwayStations.locationsTo" />
      </div>
    </div>
  </div>
</template>
<script>

import api from '@/api';
import ObSelect from "common-components/src/obComponents/obSelect";
import DataList from "../components/dataList";
import BasePriceLoader from '@/pages/basePricesDataImport/modal/loader';

export default {
  name: 'CompatibleStationsModal',
  components: {
    ObSelect,
    DataList,
    BasePriceLoader,
  },
  props: {
    dataSource: {
      type: Object,
      default: () => {}
    }
  },
  async created() {
    await this.loadData();
  },
  data () {
    return {
      showLoader: false,
      locationsListFrom: [],
      locationsListTo: [],
      ralwayStations: [],
    }
  },
  computed: {
    locationsFrom() {
      let referencePointsFrom = this.locationsListFrom;
      if ( referencePointsFrom.length ) {
        return referencePointsFrom.map(item => item.uuid);
      } else {
        return [];
      }
    },
    locationsTo() {
      let referencePointsTo = this.locationsListTo;
      if ( referencePointsTo.length ) {
        return referencePointsTo.map(item => item.uuid);
      } else {
        return [];
      }
    },
  },
  methods: {
    async loadData() {
      this.showLoader = true;
      if ( this.dataSource.clusterFromUuid ) {
        this.locationsListFrom = await this.getLocationsInAgglomeration(this.dataSource.clusterFromUuid);
      }
      if( this.dataSource.clusterToUuid ) {
        this.locationsListTo = await this.getLocationsInAgglomeration(this.dataSource.clusterToUuid);
      }
      if( this.dataSource.clusterToUuid ) {
        this.ralwayStations = await this.getStation(this.dataSource.directionUuid);
      }
      this.showLoader = false;
    },
    dataFromLocations(list, type) {
      if ( this[list] && this[list].length ) {
        return this[list].filter(location => location.locationTypeCode === type);
      } else {
        return [];
      }
    },
    async getLocationsInAgglomeration(uuid) {
      try {
        return await api.locations.getLocationsInAgglomeration(uuid);
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
        return [];
      }
    },
    async getStation(uuid) {
      try {
        return await api.locations.getContainerRouteLocations(uuid);
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
        return [];
      }
    },
  }
}

</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.compatible-stations{

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 20px;

    &.min{
      font-size: 16px;
      margin-bottom: 10px;
    }
  }

  &__select{
    margin-bottom: 30px;
  }

}

</style>
